<?php
// $Id: styles.theme.inc,v 1.1.2.1.2.2 2010/07/30 18:29:58 aaron Exp $

/**
 * @file styles.theme.inc
 * Theme and preprocess functions for the Styles project.
 */

function theme_field_formatter_styles($element = NULL) {
// dpm($element);
  $formatter = $element['#formatter'];
  $object = (object)$element['#item'];
  $output = '';
  if (preg_match('@^styles_(.*?)_(.*?)$@i', $formatter, $matches)) {
    $field_type = $matches[1];
    $style_name = $matches[2];
    $output = theme('styles', $field_type, $style_name, $object);
  }
  return $output;
}

function template_preprocess_styles(&$variables) {
  $field_type = $variables['field_type'];
  $style_name = $variables['style_name'];

  // Grab the containers for this field type.
  $containers = styles_default_containers($field_type);
  $variables['containers'] = $containers['containers'];
  $callback = $containers['filter callback'];

  // Find the correct container for this field type's styles.
  if (function_exists($callback)) {
    $container = call_user_func_array($callback, array($variables['object'], $variables));
    $variables['container'] = $container && isset($variables['containers'][$container]) ? $variables['containers'][$container] : array();
  }
  else {
    $variables['container'] = array();
  }

  // Grab the styles.
  $styles = styles_default_styles($field_type);
  $variables['styles'] = $styles['styles'];
  $variables['style'] = $style_name && isset($variables['styles'][$style_name]) ? $variables['styles'][$style_name] : array();

  // Grab the presets.
  $presets = styles_default_presets($field_type);
  $variables['presets'] = $container && isset($presets['containers'][$container]) ? $presets['containers'][$container] : array();
  $variables['preset_style'] = isset($variables['presets']['styles'][$style_name]) ? $variables['presets']['styles'][$style_name] : array();
  $variables['preset'] = isset($variables['preset_style']['selected preset']) ? $variables['preset_style']['selected preset'] : (isset($variables['preset_style']['default preset']) ? $variables['preset_style']['default preset'] : (isset($variables['presets']['default preset']) ? $variables['presets']['default preset'] : ''));
  $variables['effects'] = ($variables['preset'] !== '') && $variables['presets']['presets'][$variables['preset']] ? $variables['presets']['presets'][$variables['preset']] : array();

  // Instantiate the class and render the output.
  if ($class = $variables['container']['class']) {
    $variables['instance'] = new $variables['container']['class']($variables['object'], $variables['effects'], $variables);
    $variables['output'] = $variables['instance']->display(TRUE);
  }
  else {
    $variables['instance'] = NULL;
    $variables['output'] = '';
  }
}
